/* 
 * This killed program will respond to the I/O Manager detecting a signal
 * for a client
 */

#include <libc.h>
#include "iomgr.h"
#include "daq.h"
#include <i86.h>

/* Some global variables to share with the interrupt handler */
extern struct dqIrProxy DQIrProxyList[];
extern int DQIrProxyCount;
extern int DQVerbose;

/* 
 * Compare function for Q entry vs process Id. 
 */
void *DQCmpFn(void *data, void *key)
{
	pid_t *p;
	struct dqProcWait *waitP;

	p = key;
	waitP = data;

	if (waitP->pid == *p)
	{
		return waitP;
	}
	else
	{
		return NULL;
	}
	
}

/* 
 * This function is called proc_killed because it will override the
 * default function in iomgr.a of the same name.
 */
proc_killed(int pid)
{

	int i=0;
	pid_t p;
	struct procWait *waitQ;

	p=(pid_t)pid;
	
	/* 
	 * Check for the incoming pid to be in any of the known 
 	 * device's procWait Queues.
	 */
	if (DQVerbose) printf("Detected signal to proc: %d\n", pid);
	for (i=0; i < DQIrProxyCount;i++)
	{
		while ((waitQ = DQDetachQ(&DQIrProxyList[i].dev->procWaitQ,
				 DQCmpFn, &p)) != NULL)
		{
			if (DQVerbose ) printf("Removed proc: %d from blocked list\n", p);
			free(waitQ);
			reply_errno(pid, EINTR);
		}
	}
}

