#include <unistd.h>
#include <sys/uio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "daq_if.h"

/*
 * This test program will open /testdaq/a which requires the daq
 * program to be started with "daq -p /testdaq a" command line.
 * It will then perform 5 reads of 2 bytes,
 * 1 read of 512 bytes, an qnx_ioctl and then a close.
 * The device /testdaq/a needs to be chmod to 777 to allow O_RDWR.
 */
main()
{
	int fd, newFd;
	char buf[513];
	int nbytes;
	int i=0;
	int retVal;
	struct daq_ioctl_request request;
	struct daq_ioctl_reply reply;

	if ((fd = open("/testdaq/a", O_RDWR)) != -1)
	{
	    while(i<5)
	    {
		if ((nbytes = read(fd,buf,2)) != 2)
		{
			printf("Failed read. Only read %d bytes\n",nbytes);	
			exit();
		}
		else
		{
			buf[2] = 0;
			printf("%s\n", buf);
		}
		i++;
	   }
	   if ((nbytes = read(fd, buf, 512)) != 512)
	   {
		printf("Failed read. Only read %d bytes\n",nbytes);	
		exit();
	   }
	   else
	   {
		buf[512] = 0;
		printf("%s\n", buf);
	   }
	   retVal = qnx_ioctl(fd, DAQ_REQ_LIST_DEV, &request, sizeof(request),
			&reply, sizeof(reply));

	  printf("qnx_ioctl's return value is: %d\n",retVal);
		
	}
	else
	{
		printf("Open failed\n");
	}

		
}
