

/*-
 * an example io device. -- just responds enxio.
 */

#include <libc.h>
#include "iomgr.h"

#include <sys/io_msg.h>
#include <sys/kernel.h>

#define LIM 512
static char q[LIM];
static int head, tail;

static int
put(int c)
{
	int ntail;
	if ((ntail=tail+1)==LIM)
		ntail = 0;
	if (ntail == head) { /* full */
		return -1;
	}
	return q[tail=ntail]=c;
}

static int
get()
{
	int c;
	if (head==tail)
		return -1; /* EMPTY */
	c = q[head];
	head = head==LIM-1?0:head+1;
	return c;
}

static
echo_write(pid_t p, file_t *f, unsigned n, char *buf, unsigned len)
{
	struct _io_write_reply w;
	int      i;
	for (i=0;i < len; i++) {
		put(buf[i]);
	}
	w.status = EOK;
	w.nbytes = len;
	w.zero  = 0;
	Reply(p, &w, sizeof w);
}

static
echo_read(pid_t p, file_t *f, unsigned n)
{
	struct {
		struct _io_read_reply  rhdr;
		char                   xdata[255];
	} r;
	int      i;
	r.rhdr.status = EOK;
	r.rhdr.zero = 0;
	for (i=0; i < n && i <= sizeof r.xdata; i++) {
		int c;
		if ((c=get()) == -1)
			break;
		r.rhdr.data[i] = c;
	}
	r.rhdr.nbytes = i;
	Reply(p, &r, sizeof r);
}

err_t
create_dev(inode_t **ip)
{
	inode_t     *io;
	static   iofuns nullclass;
	nullclass.write = echo_write;
	nullclass.read  = echo_read;
	if ((io=inode_alloc(&nullclass))==0)
		return ENOMEM;
	*ip = io;
	return EOK;
}
