
/*
 *  writer.c
 *
 *  This is the tester program for the io manager exercise (iorecv.c).
 *
 *  Run it as: writer directory_for_device/device_name message_to_send
 *  Example: writer /mydevices/devicea Hello
 *
 *  1997 03 03  S. Dufresne     created
*/

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

/*
 *  our global variables.
*/

char    *progname = "writer";

main( int argc, char *argv[] )
{
    int fd;
    
    if ( argc != 3 ) {
        printf( "use: writer directory_for_device/device_name message_to_send\n" );
        printf( "Example: writer /mydevices/devicea Hello\n" );
        exit( EXIT_FAILURE );
    }

    if ( (fd = open( argv[1], O_WRONLY )) == -1 ) {
        printf( "%s: could not open %s: %s\n",
                progname, argv[1], strerror(errno) );
        exit( EXIT_FAILURE );
    }
    
    if ( write( fd, argv[2], strlen(argv[2]) + 1 ) == -1 ) {
        printf( "%s: could not write '%s': %s\n",
                progname, argv[2], strerror(errno) );
        exit( EXIT_FAILURE );
    }

    close( fd );
}
