/*-
 * copyin data for write; copyout data from read.
 */
#include "iomgr.h"
#include <stddef.h>
#include <sys/io_msg.h>
#include <sys/kernel.h>
#include <sys/uio.h>


int
wcopyin(proc_t p, ulong_t off, char *buf, ulong_t n)
{
	int     t;
	t = Readmsg(p, offsetof(struct _io_write, data)+off,
	              buf, n);
	if (t == -1) {
		return -1;
	}
	if (t < n) {
		errno = EFAULT;
		return -1;
	}
	return t;
}

int
rcopyout(proc_t p, ulong_t off, char *buf, ulong_t n)
{
	int     t;
	if ((t=Writemsg(p, offsetof(struct _io_read_reply, data)+off, buf, n))==-1) {
		return -1;
	} else if (t < n) {
		errno = EFAULT;
		return -1;
	}
	return t;
}
