/*- default close routine: just returns EOK */
#include <sys/io_msg.h>
#include <sys/kernel.h>
#include "iointernal.h"


iodef_creat(inode_t *dir, inode_t **ip)
{
	USED(dir); USED(ip);
	return ENOSYS;
}

iodef_ioctl()
{
	return ENOSYS;
}

iodef_link(inode_t *dir, char *name, inode_t *file)
{
	USED(dir); USED(name); USED(file);
	return ENOTDIR;
}

iodef_lookup(inode_t *dir, char *name, inode_t **res)
{
	USED(dir); USED(name); USED(res);
	return ENOTDIR;
}


iodef_unlink(inode_t *dir, char *name)
{
	USED(dir); USED(name);
	return ENOTDIR;
}

iodef_setsize(inode_t *dir, ulong_t len)
{
	USED(dir); USED(len);
	return EOK;
}

iodef_close(file_t *f)
{
	USED(f);
	return EOK;
}
iodef_open(proc_t p, file_t *f, mode_t m)
{
	USED(p); USED(m); USED(f);
	return EOK;
}

iodef_read(pid_t pid, file_t *m, void *p, ulong_t nbytes)
{
	USED(p); USED(m); USED(nbytes);
	return reply_read(pid, 0, 0);
}

int
iodef_write(pid_t pid, file_t *m, unsigned n, void *p, unsigned len)
{
	struct _io_write_reply rep;
	USED(m); USED(p); USED(n); USED(len);
	rep.status = EOK;
	rep.zero   = 0;
	rep.nbytes = n;
	return Reply(pid, &rep, sizeof rep);
}

int
iodef_qioctl(pid_t pid, file_t *m, unsigned request, 
		unsigned n, void *p, unsigned len)
{
	struct _io_qioctl_reply rep;
	USED(m); USED(p); USED(n); USED(len);
	rep.status = EOK;
	rep.ret_val   = 0;
	return Reply(pid, &rep, sizeof rep);
}
