
/*-
 * fd: grungy filedescriptor/qnx system interface.
 *
 *  The mysterious __init_fd(), __get_fd() and __get_pid_info()
 * are covered here and associated with the internal file table
 * structures.
 *  The file structures are hard-coded as limits; it would be
 * nicer to have runtimes.
 */

#include <stdlib.h>
#include <string.h>
#include "iointernal.h"

#define MAX_FILES 128
file_t file_table[MAX_FILES];

file_t *
index2f(int n)
{
	return __index2f(n);
}

int
f2index(file_t *f)
{
	return f-file_table+1;
}


file_t *
falloc(void)
{
	file_t    *f;
	for (f=file_table; f < file_table+MAX_FILES; f++) {
		if (f->inode == 0) {
			return f;
		}
	}
	return (file_t *)0;
}
void
ffree(file_t *p)
{
	memset(p, 0, sizeof *p);
}
