/*-
 * fs_mkdir: attempt to create a new directory.
 *
 */
#include "iointernal.h"


fs_mkdir(pid_t pid, char *path, inode_t *dir, mode_t modes)
{
	inode_t       *n;
	int            e;
	char           comp[NAME_MAX+1];

	if ((e=nameip(pid, path, FEXEC, dir, &dir, comp)) != EOK) {
		return reply_errno(pid, e);
	}
	if ((e=d_lookup(dir, comp, &n)) == EOK) {
		return reply_errno(pid, EEXIST);
	}
	if ((n=create_dir(ino_creat(dir))) == 0) {
		return reply_errno(pid, ENOMEM);
	}
	d_link(n, ".", n);
	d_link(n, "..", dir);
	d_link(dir, comp, n);
	return reply_errno(pid, EOK);
}
