
#include <signal.h>
#include <sys/io_msg.h>
#include <sys/kernel.h>
#include "iointernal.h"

int
io_lseek(pid_t pid, file_t *f, int whence, off_t offset)
{
	struct _io_lseek_reply rep;
	if(f == (file_t *)0 || f == (file_t *)-1) {
		return reply_errno(pid, EBADF);
	}
	rep.status = EOK;
	switch (whence) {
	case SEEK_CUR:
		offset += f->offset;
		break;
	case SEEK_SET:
		break;
	case SEEK_END:
		offset = d_size(f->inode) - offset;
		break;
	default:
		kill(pid, SIGSYS);
		return reply_errno(pid, EINVAL);
	}
	if (offset < 0) {
		return reply_errno(pid, EINVAL);
	}
	f->offset =  offset;

	rep.status = EOK;
	rep.zero   = 0;
	rep.offset = offset;
	return Reply(pid, &rep, sizeof rep);
}
