/*-
 * io_stat() - find the name and return it's stat structure
 */

#include <sys/io_msg.h>
#include <sys/kernel.h>
#include "iointernal.h"


io_stat(pid_t pid, char *path, inode_t *root)
{
	struct _io_fstat_reply          rep;
	inode_t       *p;
	int            e;

	if ((e=namei(pid, path, FREAD, root, &p)) != EOK) {
		return reply_errno(pid, e);
	}
	rep.status = EOK;
	ino2stat(&rep.stat, p);
	Reply(pid, &rep, sizeof rep);
	return 0;
}
