
/*- server: main loop and message dispatch */
#include <sys/sys_msg.h>
#include <sys/kernel.h>
#include "iointernal.h"
#include "iomessage.h"

extern struct _sysmsg_version_reply version_stamp;

sys_message(pid_t pid, sys_msg *sys, unsigned len)
{
	sys_reply            r;
	struct _mxfer_entry  mx[2];
	USED(len);
	switch (sys->hdr.subtype) {
	case _SYSMSG_SUBTYPE_DEATH:
		reply_errno(pid, ENOSYS);
		break;

	case _SYSMSG_SUBTYPE_SIGNAL:
		proc_killed(pid);
		break;

	case _SYSMSG_SUBTYPE_TRACE:
		reply_errno(pid, ENOSYS);
		break;

	case _SYSMSG_SUBTYPE_VERSION:
		r.hdr.status = EOK;
		_setmx(mx+0, &r.hdr, sizeof r.hdr);
		_setmx(mx+1, &version_stamp, sizeof version_stamp);
		Replymx(pid, 2, &mx);
		break;

	case _SYSMSG_SUBTYPE_SLIB:
		reply_errno(pid, ENOSYS);
		break;
	default:
		reply_errno(pid, ENOSYS);
		break;
	}
	return 0;
}
