
#include <sys/types.h>
#include <sys/stat.h>
#include "iointernal.h"


chk_perm(uid_t u, gid_t g, mode_t mode, inode_t *obj)
{
	unsigned        okmode;
	unsigned        fuid, fgid;
	mode_t          fmode;

	fuid = d_owner(obj);
	if (mode == FNONE)
		return EOK;
	if (mode == FOWNER) {
		return (u == 0 || u == fuid) ?  EOK : EPERM;
	}
	fgid = d_group(obj);
	fmode = d_mode(obj);
	if (u == 0) {
		okmode = S_IRWXO;
	} else if (u == fuid) {
		okmode = (fmode >> 6) & 007;
	} else if (g == fgid) {
		okmode = (fmode >> 3) & 007;
	} else {
		okmode = fmode & 007;
	}
	mode &= FACC;
	return (mode&okmode)==mode ? EOK : EPERM;
}
