
#include "externs.h"
#include "iointernal.h"
#include "iomessage.h"

#define MSG_CLASS(m) ((m)>>8)

#define DIR_READ_SIZE sizeof(struct dirent)
#define    NROOTS  16
static inode_t   *fstab[NROOTS];
static int        nfs;
static int        major;

extern _qnx_prefix_attach(pid_t, char *, char *, unsigned unit);

int
getunit(int index)
{
	return index<nfs ? index : -1;
}

inode_t *
getroot(int unitno)
{
	return unitno<nfs?fstab[unitno]: 0;
}

int
root_mount(char *path)
{
	int    err;
	if (nfs >= NROOTS) {
		return ENFILE;
	}
	if ((err=_qnx_prefix_attach(PROC_PID, path, 0, nfs)) != EOK) {
		return err;
	}
	fstab[nfs] = create_dir(0);
	/*-
	 * create a root directory
	 */
	d_link(fstab[nfs], ".", fstab[nfs]);
	d_link(fstab[nfs], "..", fstab[nfs]);
	nfs++;
	return EOK;
}


proc_io()
{
	switch (MSG_CLASS(msg.type)) {
	case _IO_CLASS:
		io_message(pid, (io_msg *)&msg, sizeof msg);
		break;
	case _FS_CLASS:
		fs_message(pid, (fs_msg *)&msg, sizeof msg);
		break;
	case _DEV_CLASS:
		dev_message(pid, (dev_msg *)&msg, sizeof msg);
		break;
	default:
		reply_errno(pid, ENOSYS);
	}
	return 0;
}
