/*- reply_read(), reply_readv() - assemble response to read(). */

#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/io_msg.h>
#include "iomgr.h"

int
reply_read(pid_t pid, void *b, int n)
{
	struct _mxfer_entry      mx[2];
	struct _io_read_reply    r;
	r.status = EOK;
	r.zero   = 0;
	r.nbytes = n;
	_setmx(mx+0, &r, _offof(r, data));
	_setmx(mx+1, b, n);
	return Replymx(pid, 2, mx);
}

int
reply_readv(pid_t pid, int n, struct iovec *v)
{
	struct _mxfer_entry     *mx;
	struct _io_read_reply    r;
	int                      i;
	mx = alloca(sizeof *mx *(n+1));
	_setmx(mx, &r, _offof(r, data));
	r.status = EOK;
	r.zero   = 0;
	r.nbytes = 0;
	for (i=0; i < n; i++) {
		_setmx(mx+i+1, v[i].iov_base, v[i].iov_len);
		r.nbytes += v[i].iov_len;
	}
	return Replymx(pid, n+1, mx);
}
