/*- root: maintain a forest of namespaces.
 */

#include <dirent.h>
#include <sys/fd.h>
#include <sys/prfx.h>
#include "iointernal.h"

#define DIR_READ_SIZE sizeof(struct dirent)
#define    NROOTS  16
static inode_t   *fstab[NROOTS];
static int        nfs;

int
getunit(int index)
{
	return index<nfs ? index : -1;
}

inode_t *
getroot(int unitno)
{
	return unitno<nfs?fstab[unitno]: 0;
}

long
getmajor()
{
	return qnx_device_attach();
}

int
root_mount(char *path, inode_t *i)
{
	if (nfs >= NROOTS) {
		return ENFILE;
	}
	if ((qnx_prefix_attach(path, 0, nfs)) == -1) {
		return errno;
	}
	fstab[nfs++] = i;
	return EOK;
}
